> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create sequence sets

POST https://rest.test.zuora.com/v1/sequence-sets
Content-Type: application/json

Creates sequence sets, allowing distinct numbering sequences for billing documents, payments, and refunds. Billing documents include invoices, credit memos, and debit memos.

You can create a maximum of 100 sequence sets in one single request. A sequence set comprises a set of custom prefixes and starting numbers that are used for billing documents to generate, and payments and refunds to create.

See [Prefix and Numbering Configuration for Billing Documents](https://knowledgecenter.zuora.com/CB_Billing/Billing_Settings/Prefix_and_Numbering_Configuration_for_Billing_Documents) for more information about limitations.

**Note**: The Credit and Debit Memos feature is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. 


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/sequence-sets/post-sequence-sets

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTSequenceSetsRequest.

- `sequenceSets` (list of POSTSequenceSetRequest, optional) — Array of sequence sets configured for billing documents, payments, and refunds.

## Response

### 200

OK

- `sequenceSets` (list of GETSequenceSetResponse, optional) — Array of sequence sets configured for billing documents, payments, and refunds.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### POSTSequenceSetRequest

- `creditMemo` (CreditMemoEntityPrefix, required) — Container for the prefix and starting document number of credit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `debitMemo` (DebitMemoEntityPrefix, required) — Container for the prefix and starting document number of debit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `invoice` (InvoiceEntityPrefix, required) — Container for the prefix and starting document number of invoices.
- `name` (string, required) — The name of the sequence set to configure for billing documents, payments, and refunds.
- `sequenceSetNumber` (string, optional) — Specifies the sequence set number to assign when creating the sequence set. **Note:** This value is set only during creation and cannot be updated after the sequence set is created.
- `payment` (PaymentEntityPrefix, optional) — Container for the prefix and starting number of payments.
- `refund` (RefundEntityPrefix, optional) — Container for the prefix and starting number of refunds.

### GETSequenceSetResponse

- `creditMemo` (CreditMemoEntityPrefix, optional) — Container for the prefix and starting document number of credit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `debitMemo` (DebitMemoEntityPrefix, optional) — Container for the prefix and starting document number of debit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `id` (string, optional) — The unique ID of the sequence set. For example, 402892c74c9193cd014c96bbe7c101f9.
- `invoice` (InvoiceEntityPrefix, optional) — Container for the prefix and starting document number of invoices.
- `name` (string, optional) — The name of the sequence set.
- `payment` (PaymentEntityPrefix, optional) — Container for the prefix and starting number of payments.
- `refund` (RefundEntityPrefix, optional) — Container for the prefix and starting number of refunds.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CreditMemoEntityPrefix

Container for the prefix and starting document number of credit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.

- `prefix` (string, optional) — The prefix of credit memos.
- `startNumber` (integer, optional) — The starting document number of credit memos.

### DebitMemoEntityPrefix

Container for the prefix and starting document number of debit memos. **Note:** This field is only available if you have the Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.

- `prefix` (string, optional) — The prefix of debit memos.
- `startNumber` (integer, optional) — The starting document number of debit memos.

### InvoiceEntityPrefix

Container for the prefix and starting document number of invoices.

- `prefix` (string, optional) — The prefix of invoices.
- `startNumber` (integer, optional) — The starting document number of invoices.

### PaymentEntityPrefix

Container for the prefix and starting number of payments.

- `prefix` (string, optional) — The prefix of payments.
- `startNumber` (integer, optional) — The starting number of payments.

### RefundEntityPrefix

Container for the prefix and starting number of refunds.

- `prefix` (string, optional) — The prefix of refunds.
- `startNumber` (integer, optional) — The starting number of refunds.

## Examples

**Request**

```json
{
  "sequenceSets": [
    {
      "creditMemo": {
        "prefix": "FCM",
        "startNumber": 10
      },
      "debitMemo": {
        "prefix": "FDM",
        "startNumber": 10
      },
      "invoice": {
        "prefix": "FINV",
        "startNumber": 10
      },
      "name": "FR",
      "sequenceSetNumber": "FR",
      "payment": {
        "prefix": "FP-",
        "startNumber": 10
      },
      "refund": {
        "prefix": "FR-",
        "startNumber": 10
      }
    }
  ]
}
```

**Response**

```json
{
  "sequenceSets": [
    {
      "creditMemo": {
        "prefix": "FCM",
        "startNumber": 10
      },
      "debitMemo": {
        "prefix": "FDM",
        "startNumber": 10
      },
      "id": "402892c74c9193cd014c96bbe7c101f9",
      "invoice": {
        "prefix": "FINV",
        "startNumber": 10
      },
      "name": "FR",
      "payment": {
        "prefix": "FP-",
        "startNumber": 10
      },
      "refund": {
        "prefix": "FR-",
        "startNumber": 10
      }
    }
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/sequence-sets"

payload = { "sequenceSets": [
        {
            "creditMemo": {
                "prefix": "FCM",
                "startNumber": 10
            },
            "debitMemo": {
                "prefix": "FDM",
                "startNumber": 10
            },
            "invoice": {
                "prefix": "FINV",
                "startNumber": 10
            },
            "name": "FR",
            "sequenceSetNumber": "FR",
            "payment": {
                "prefix": "FP-",
                "startNumber": 10
            },
            "refund": {
                "prefix": "FR-",
                "startNumber": 10
            }
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/sequence-sets';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"sequenceSets":[{"creditMemo":{"prefix":"FCM","startNumber":10},"debitMemo":{"prefix":"FDM","startNumber":10},"invoice":{"prefix":"FINV","startNumber":10},"name":"FR","sequenceSetNumber":"FR","payment":{"prefix":"FP-","startNumber":10},"refund":{"prefix":"FR-","startNumber":10}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/sequence-sets"

	payload := strings.NewReader("{\n  \"sequenceSets\": [\n    {\n      \"creditMemo\": {\n        \"prefix\": \"FCM\",\n        \"startNumber\": 10\n      },\n      \"debitMemo\": {\n        \"prefix\": \"FDM\",\n        \"startNumber\": 10\n      },\n      \"invoice\": {\n        \"prefix\": \"FINV\",\n        \"startNumber\": 10\n      },\n      \"name\": \"FR\",\n      \"sequenceSetNumber\": \"FR\",\n      \"payment\": {\n        \"prefix\": \"FP-\",\n        \"startNumber\": 10\n      },\n      \"refund\": {\n        \"prefix\": \"FR-\",\n        \"startNumber\": 10\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/sequence-sets")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"sequenceSets\": [\n    {\n      \"creditMemo\": {\n        \"prefix\": \"FCM\",\n        \"startNumber\": 10\n      },\n      \"debitMemo\": {\n        \"prefix\": \"FDM\",\n        \"startNumber\": 10\n      },\n      \"invoice\": {\n        \"prefix\": \"FINV\",\n        \"startNumber\": 10\n      },\n      \"name\": \"FR\",\n      \"sequenceSetNumber\": \"FR\",\n      \"payment\": {\n        \"prefix\": \"FP-\",\n        \"startNumber\": 10\n      },\n      \"refund\": {\n        \"prefix\": \"FR-\",\n        \"startNumber\": 10\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/sequence-sets")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"sequenceSets\": [\n    {\n      \"creditMemo\": {\n        \"prefix\": \"FCM\",\n        \"startNumber\": 10\n      },\n      \"debitMemo\": {\n        \"prefix\": \"FDM\",\n        \"startNumber\": 10\n      },\n      \"invoice\": {\n        \"prefix\": \"FINV\",\n        \"startNumber\": 10\n      },\n      \"name\": \"FR\",\n      \"sequenceSetNumber\": \"FR\",\n      \"payment\": {\n        \"prefix\": \"FP-\",\n        \"startNumber\": 10\n      },\n      \"refund\": {\n        \"prefix\": \"FR-\",\n        \"startNumber\": 10\n      }\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/sequence-sets', [
  'body' => '{
  "sequenceSets": [
    {
      "creditMemo": {
        "prefix": "FCM",
        "startNumber": 10
      },
      "debitMemo": {
        "prefix": "FDM",
        "startNumber": 10
      },
      "invoice": {
        "prefix": "FINV",
        "startNumber": 10
      },
      "name": "FR",
      "sequenceSetNumber": "FR",
      "payment": {
        "prefix": "FP-",
        "startNumber": 10
      },
      "refund": {
        "prefix": "FR-",
        "startNumber": 10
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/sequence-sets");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"sequenceSets\": [\n    {\n      \"creditMemo\": {\n        \"prefix\": \"FCM\",\n        \"startNumber\": 10\n      },\n      \"debitMemo\": {\n        \"prefix\": \"FDM\",\n        \"startNumber\": 10\n      },\n      \"invoice\": {\n        \"prefix\": \"FINV\",\n        \"startNumber\": 10\n      },\n      \"name\": \"FR\",\n      \"sequenceSetNumber\": \"FR\",\n      \"payment\": {\n        \"prefix\": \"FP-\",\n        \"startNumber\": 10\n      },\n      \"refund\": {\n        \"prefix\": \"FR-\",\n        \"startNumber\": 10\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["sequenceSets": [
    [
      "creditMemo": [
        "prefix": "FCM",
        "startNumber": 10
      ],
      "debitMemo": [
        "prefix": "FDM",
        "startNumber": 10
      ],
      "invoice": [
        "prefix": "FINV",
        "startNumber": 10
      ],
      "name": "FR",
      "sequenceSetNumber": "FR",
      "payment": [
        "prefix": "FP-",
        "startNumber": 10
      ],
      "refund": [
        "prefix": "FR-",
        "startNumber": 10
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/sequence-sets")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```